function loadPrograms() {
  try {
    var file = localFile.init(gProfileDir.path + gSlash + "fireFTPprograms.dat");

    if (file.exists()) {
      var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
      var sstream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
      fstream.init(file, 1, 0, false);
      sstream.init(fstream);

      var programData = "";
      var str = sstream.read(-1);

      while (str.length > 0) {
        programData += str;
        str          = sstream.read(-1);
      }

      gPrograms = eval(programData);

      sstream.close();
      fstream.close();
    } else {
      gPrograms = new Array({ extension: "*.*", programs: new Array() });
      savePrograms();
    }
  } catch (ex) {
    debug(ex);
  }
}

function savePrograms() {
  try {
    var file       = localFile.init(gProfileDir.path + gSlash + "fireFTPprograms.dat");
    var foutstream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
    foutstream.init(file, 0x04 | 0x08 | 0x20, 0644, 0);
    foutstream.write(gPrograms.toSource(), gPrograms.toSource().length);
    foutstream.close();
  } catch (ex) {
    debug(ex);
  }
}

function chooseProgram() {
  var result       = { value: false };
  var extension    = localTree.getExtension(localTree.data[localTree.selection.currentIndex].leafName);
  var tempPrograms = { value: new Array(), extension: extension };

  for (var x = 0; x < gPrograms.length; ++x) {
    tempPrograms.value.push(gPrograms[x]);
  }

  window.openDialog("chrome://fireftp/content/programs.xul", "programs", "chrome,modal,dialog,resizable,centerscreen", tempPrograms, result);

  if (result.value) {
    gPrograms = tempPrograms.value;
    savePrograms();
  }
}

function launchProgram(extensionIndex, programIndex, fileIndex) {
  try {
    var program = localFile.init(gPrograms[extensionIndex].programs[programIndex].executable);
    var process = Components.classes['@mozilla.org/process/util;1'].getService(Components.interfaces.nsIProcess);
    process.init(program);
    var arguments = new Array();

    if (!gPrograms[extensionIndex].programs[programIndex].arguments) {
      arguments.push(localTree.data[fileIndex].path);
    } else {
      var argumentString = gPrograms[extensionIndex].programs[programIndex].arguments;

      while (argumentString.indexOf("%file%") != -1) {
        argumentString = argumentString.substring(0, argumentString.indexOf("%file%"))
                       + localTree.data[fileIndex].path
                       + argumentString.substring(argumentString.indexOf("%file%") + 6, argumentString.length);
      }

      arguments.push(argumentString);
    }

    process.run(false, arguments, arguments.length, {});

  } catch (ex) {
    debug(ex);
  }
}
